/* PSFPController */

#import <Cocoa/Cocoa.h>
#import "PSFPlayer.h"
#import "PSFPConverter.h"

@interface PSFPController : NSObject
{
    IBOutlet id playListTable;
	IBOutlet id mainWindow;
	IBOutlet id playingTime;
	IBOutlet id statusText;
	IBOutlet id currentFile;
	IBOutlet id playButton;
	IBOutlet id stopButton;
	IBOutlet id convertMenu;
	IBOutlet id prefPane;
	IBOutlet id fixedOutputDir;
	IBOutlet id setOutputDirButton;
	IBOutlet id dupRadio;
	IBOutlet id outputRadio;
	IBOutlet id autoSaveFlag;
	IBOutlet id skipButton;
	IBOutlet id reverseButton;
	IBOutlet id subdirectoryDepth;
	IBOutlet id depthStepper;
	IBOutlet id unlimitedCheck;
	IBOutlet id opacitySlider;
	IBOutlet id texturedCheck;
	IBOutlet id windowLevelPopup;
	IBOutlet id titleCheckBox;
	IBOutlet id playTimeField;
	IBOutlet id fadeOutField;
	IBOutlet id playTimeRadio;
	IBOutlet id channelPane;
	IBOutlet id spcCh1;
	IBOutlet id spcCh2;
	IBOutlet id spcCh3;
	IBOutlet id spcCh4;
	IBOutlet id spcCh5;
	IBOutlet id spcCh6;
	IBOutlet id spcCh7;
	IBOutlet id spcCh8;
	IBOutlet id psfCh1;
	IBOutlet id psfCh2;
	IBOutlet id psfCh3;
	IBOutlet id psfCh4;
	IBOutlet id psfCh5;
	IBOutlet id psfCh6;
	IBOutlet id psfCh7;
	IBOutlet id psfCh8;
	IBOutlet id psfCh9;
	IBOutlet id psfCh10;
	IBOutlet id psfCh11;
	IBOutlet id psfCh12;
	IBOutlet id psfCh13;
	IBOutlet id psfCh14;
	IBOutlet id psfCh15;
	IBOutlet id psfCh16;
	IBOutlet id psfCh17;
	IBOutlet id psfCh18;
	IBOutlet id psfCh19;
	IBOutlet id psfCh20;
	IBOutlet id psfCh21;
	IBOutlet id psfCh22;
	IBOutlet id psfCh23;
	IBOutlet id psfCh24;
	IBOutlet id reverbType;
	IBOutlet id reverbEnabledSPC;
	IBOutlet id reverbEnabledPSF;
	IBOutlet id reverbStrength;
	IBOutlet id interpolationMethod;
	PSFPlayer *player;
	PSFPConverter *converter;
    NSMutableArray *playListArray;
	NSMutableArray *playListStatusArray;
	NSMutableArray *playListTitleArray;
	NSString *playingFile;
	BOOL nowPlaying;
	BOOL nowConverting;
	BOOL launched;
}
- (IBAction)play:(id)sender;
- (IBAction)stop:(id)sender;
- (IBAction)onDoubleClick:(id)sender;
- (IBAction)convert:(id)sender;
- (IBAction)prefCancel:(id)sender;
- (IBAction)prefOK:(id)sender;
- (IBAction)showPref:(id)sender;
- (IBAction)enableOutputDir:(id)sender;
- (IBAction)setOutputDir:(id)sender;
- (IBAction)skip:(id)sender;
- (IBAction)reverse:(id)sender;
- (IBAction)toggleUnlimited:(id)sender;
- (IBAction)setWindowOpacity:(id)sender;
- (IBAction)toggleWindowAppearance:(id)sender;
- (IBAction)setWindowLevel:(id)sender;
- (IBAction)toggleTitle:(id)sender;
- (IBAction)setChannelMuteSPC:(id)sender;
- (IBAction)setChannelMutePSF:(id)sender;
- (IBAction)showChannelPane:(id)sender;
- (void)convertDone:(NSString *)doneFile;
- (void)convertComplete:(NSString *)doneFile;
- (void)clearStatus;
- (void)convertTerminated;
- (void)savePrefs;
- (void)loadPrefs;
- (void)playFileAtIndex:(int)index;
- (void)playDone;
- (void)removeSelectedFile:(id)table;
- (int)appendFile:(NSArray *)files atIndex: (int)index recursion: (int)r;
- (void)setPlayTime:(NSString *) time;
- (NSString *)getMusicTitle:(NSString *)str;
- (NSString *)playTime;
- (NSString *)fadeOut;
- (BOOL)forcePlayTime;
- (NSString *)createChannelMaskforSPC;
- (NSString *)createChannelMaskforPSF;
- (BOOL)reverbEnabledSPC;
- (BOOL)reverbEnabledPSF;
- (int)reverbType;
- (int)reverbStrength;
- (int)interpolationMethod;
@end
